Subject: Re: bug#30553: 26.0.91; underline appears beneath line-spacing rather than beneath text

From: Eli Zaretskii <[email-masked]>
Date: Wed, 21 Feb 2018 19:56:13 +0200

> From: Aaron Jensen <[email-masked]>
> Date: Wed, 21 Feb 2018 08:17:34 -0800
> Cc: Eli Zaretskii <[email-masked]>, [email-masked]
> 
> On Wed, Feb 21, 2018 at 5:47 AM, Alp Aker <[email-masked]> wrote:
> > On Wed, Feb 21, 2018 at 1:03 AM, Aaron Jensen <[email-masked]> wrote:
> > Something like that should already be possible.  Underline placement is
> > determined by the following rules, considered in this order:
> >
> > 1. If x-underline-at-descent-line is non-nil, underline at the descent line,
> > where the descent line is the bottom of the current glyph row, inclusive of
> > extra line spacing.
> 
> I'm specifically talking about this rule. I am suggesting that this
> change to not include the extra line spacing. Typographically, I
> cannot think of a good reason to include the extra line spacing. It
> ends up putting the underline above the next line effectively, which
> looks terrible (see my original screenshots). Given that rule #3 you
> mention below uses half the descent, it seems like the full descent +
> 1px could be used for this, which would put the underline in a
> sensible place (probably the place it is today when line-spacing is
> nil).

Feel free to submit patches to introduce this as yet another optional
behavior.  We cannot just throw out the current behavior, because it
was with us since Emacs 21.

Note that this feature has 3 implementations, one each in every GUI
back-end we support.

Thanks.